# Retrieve a list of available behavior table of specified step

Retrieve a list of available behavior table of specified step.

Endpoint: POST /entities/journeys/{journeyId}/available_behaviors_for_step
Version: 1.0.0
Security: TdApikeyAuth

## Path parameters:

  - `journeyId` (integer, required)
    Journey ID

## Query parameters:

  - `stepId` (string)

## Request fields (application/vnd.treasuredata.v1+json):

  - `type` (string)
    Enum: "journey"

  - `attributes` (object)

  - `attributes.name` (string, required)

  - `attributes.description` (string,null)

  - `attributes.state` (string)
    Enum: "draft", "simulation", "launched"

  - `attributes.goal` (object,null)

  - `attributes.goal.name` (string, required)

  - `attributes.goal.description` (string)

  - `attributes.goal.segmentId` (string, required)

  - `attributes.goal.target` (object)

  - `attributes.goal.target.journeyId` (string, required)
    ID of an existing journey to jump to.

  - `attributes.goal.target.journeyStageId` (string, required)
    ID of an existing stage within the target journey to jump to.

  - `attributes.journeyStages` (array)

  - `attributes.journeyStages.id` (string)
    Server-generated. Omit when creating a stage; supply to target an existing stage when updating.

  - `attributes.journeyStages.name` (string, required)

  - `attributes.journeyStages.description` (string)

  - `attributes.journeyStages.steps` (object,null)

  - `attributes.journeyStages.steps.uuid` (any) — one of:
    - JourneyActivationStep:
      - `type` (any, required)
        Enum: "Activation"
      - `name` (string, required)
      - `journeyActivationStepId` (string, required)
      - `next` (string)
    - JourneyDecisionPointStep:
      - `type` (any, required)
        Enum: "DecisionPoint"
      - `name` (string, required)
      - `branches` (array, required)
      - `branches.name` (string, required)
      - `branches.segmentId` (string, required)
      - `branches.excludedPath` (boolean)
      - `branches.next` (string)
    - JourneyMergeStep:
      - `type` (any, required)
        Enum: "Merge"
      - `name` (string)
      - `next` (string)
    - JourneyJumpStep:
      - `type` (any, required)
        Enum: "Jump"
      - `name` (string, required)
      - `target` (object, required)
    - JourneyEndStep:
      - `type` (any)
        Enum: "End"
      - `name` (string)
    - JourneyAbTestStep:
      - `type` (any, required)
        Enum: "AbTest"
      - `name` (string, required)
      - `customizedSplit` (boolean, required)
      - `uniqueId` (string)
      - `enabledCapping` (boolean)
        Enables profile capping on the step
      - `variants` (array, required)
      - `variants.id` (string, required)
      - `variants.name` (string, required)
      - `variants.percentage` (number, required)
      - `variants.next` (string)
      - `variants.isControlGroup` (boolean)
        Marks a variant as the control group (required when enabledCapping is true)
      - `variants.cappingAt` (integer)
        Capping threshold per variant (required for non-control variants when capping is enabled)

  - `attributes.journeyStages.rootStep` (string)

  - `attributes.journeyStages.entryCriteria` (object,null)

  - `attributes.journeyStages.milestone` (object,null)

  - `attributes.journeyStages.exitCriterias` (array)

  - `attributes.allowReentry` (boolean)

  - `attributes.reentryMode` (string)
    Enum: "no_reentry", "reentry_unless_goal_achieved", "reentry_always"

  - `attributes.journeyBundleId` (string,null)
    Attach the journey to an existing journey bundle as its next version.

  - `attributes.journeyBundleName` (string,null)

  - `attributes.journeyBundleDescription` (string,null)

## Response 200 fields (application/json):

  - `data` (array, required)

  - `data.id` (string, required)

  - `data.type` (string, required)
    Enum: "audience-behavior"

  - `data.attributes` (object, required)

  - `data.attributes.audienceId` (string, required)

  - `data.attributes.name` (string, required)
    Behavior name user defined on Master Segment Configuration page of Data Workbench

  - `data.attributes.parentDatabaseName` (string, required)
    Database name of the behavior table

  - `data.attributes.parentTableName` (string, required)
    Table name of the behavior table

  - `data.attributes.parentKey` (string, required)
    Join key of the behavior table

  - `data.attributes.foreignKey` (string, required)
    Foreign key of the master table

  - `data.attributes.matrixDatabaseName` (string, required)
    Matrix database name of the behavior table

  - `data.attributes.matrixTableName` (string, required)
    Matrix table name of the behavior table

  - `data.attributes.allColumns` (boolean, required)

  - `data.attributes.defaultTimeFilterEnabled` (boolean, required)

  - `data.attributes.isRealtime` (boolean, required)

  - `data.attributes.schema` (array, required)
    Columns of behavior

  - `data.attributes.schema.name` (string, required)
    Column name user defined on Master Segment Configuration page of Data Workbench

  - `data.attributes.schema.type` (string, required)
    Type of the column
    Enum: "string", "number", "timestamp", "date", "string_array", "number_array", "boolean"

  - `data.attributes.schema.parentColumn` (string,null, required)
    Column name of the behavior table (This can be null when the column is an enriched column)

  - `data.attributes.schema.matrixColumnName` (string)
    Column name of the behavior table

  - `data.attributes.schema.matrixColumnDescription` (string,null)
    Description of the column in behavior table

  - `data.attributes.schema.visibility` (string)
    Enum: "clear", "pii", "non_pii", "blocked"


